---
title: FSST 2
layout: layouts/base_subject.njk
eleventyNavigation:
  key: FSST 2
  parent: FSST
  order: 2
---
<h2 id="fsst2_overview">Course Overview</h2>
<ul>
  <li><a href="/presentations/c/structs/">Typedef and Structs - Composite Data Types</a></li>
  <li><a href="/presentations/c/pointers/">Pointers</a></li>
  <li><a href="/presentations/c/dynamic_memory_management/">Dynamic Memory Management</a></li>
  <li><a href="/presentations/c/algorithms/introduction_to_algorithms/">Data Structures and Algorithms in C - Introduction</a></li>
  <li><a href="#web">Web Programming Basics</a></li>
</ul>

<h2 id="microcontroller">Microcontroller Programming</h2>
<p>We'll use the Raspberry Pi Pico and will write code both in MicroPython and
  C. For using MicroPython on the Pico, install an up to date version of
  Python 3 and the <code>thonny</code> package on your computer. To do so,
  follow the instructions at
  <a href="http://docs.find-santa.eu/python/installation.html">Installing
  Python</a>.
</p>

<p>If you don't own a MicroPython compatible device and still want to practice
  at home, you can use the
  <a href="https://wokwi.com/arduino/new?template=micropython-pi-pico">Wokwi
    RP Pico simulator</a>.
</p>

<h3>Downloads</h3>
<ul>
  <li>
    <a href="https://hackspace.raspberrypi.org/books/micropython-pico/pdf/download">
    Get Started with MicroPython on Raspberry Pi Pico</a></li>
  <li><a href="https://micropython.org/download/rp2-pico/rp2-pico-latest.uf2">
    MicroPython Firmware</a> (drag and drop on a Pi Pico)</li>
  <li>
    <a href="https://datasheets.raspberrypi.com/pico/Pico-R3-A4-Pinout.pdf">
    Pico-R3-A4-Pinout.pdf</a></li>
  <li><a href="https://www.raspberrypi.com/documentation/microcontrollers/raspberry-pi-pico.html">
    Pico Documentation (specification, MicroPython and C/C++ SDK)</a></li>
</ul>


<h2 id="web">Web Programming Basics</h2>
<p>We dedicate four sessions to this topic. After those fourse sessions you'll
  have to write a small website which you'll present the week after Easter.
</p>
<ol>
  <li>Overview of Core Web Development Technologies
    <ul>
      <li>Setting up our Development Environment</li>
      <li>Image formats - raster graphics and vector file formats</li>
    </ul>
  </li>
  <li>Introduction to HTML</li>
  <li>Introduction to CSS</li>
  <li>Introduction to JavaScript</li>
</ol>
<p>Start by setting up a mini development environment. We can either stick
  to replit or use a local installation to speed up development on our own
  machine. When going for the latter approach, I suggest using VSCodium as
  our editor. Consult
  <a href="http://docs.find-santa.eu/tools/vscodium.html">Introduction to VSCodium</a>
  to get started with this editor.
  {# TODO: Try out live-server on school PCs. If it works w/out admin privileges:
  describe installation and usage. #}
</p>

<p>
  We genereally distinguish two different kinds of graphics formats:
  <a href="https://en.wikipedia.org/wiki/Raster_graphics">raster graphics</a>
  and
  <a href="https://en.wikipedia.org/wiki/Vector_graphics">vector graphics</a>.
  For our purposes, it is enough to understand which advantages and
  disadvantages each of them has to decide which ones to chose in different
  use cases on the web.
  For raster graphics, <kbd>png</kbd> &ndash;
  <a href="https://en.wikipedia.org/wiki/Portable_Network_Graphics">
    Portable Network Graphics</a>
  is likely the best choice,
  although alternatives like <kbd>jpeg</kbd> and <kbd>gif</kbd> also work in
  many cases.
  For vector graphics, I recommend using <kbd>svg</kbd> &ndash;
  <a href="https://en.wikipedia.org/wiki/Scalable_Vector_Graphics">
    Scalable Vector Graphics</a> files.
  <ul>
    <li><a href="/images/favicon.png">favicon.png (a tiny raster graphic)</a></li>
    <li><a href="/images/circuits/diode_characteristic_forward_direction.svg">
      diode_characteristic_forward_direction.svg</a> (a vector image)</li>
  </ul>
</p>

<p>For study purposes, please use the
  <a href="https://developer.mozilla.org/en-US/docs/Learn/Getting_started_with_the_web">
    Getting started with the Web</a>, a tutorial by <strong>mdn</strong>,
    probably the best resource on web development. Alternatively, watch
  <a href="https://www.freecodecamp.org/news/learn-html-beginners-course/">
    Learn HTML – Beginner's Course</a>, a four hour web development video
    tutorial.</p>

<h3 id="web_examples">Web Programming Examples</h3>
<ul>
  <li><a href="/data/web/canvas_example.html">canvas_example.html</a></li>
</ul>

<h2 id="exercises">Programming Exercises</h2>
<ul>
  <li><a href="/data/c/functions_2.c">functions_2.c</a></li>
  <li><a href="/exercises/c/exercise_3/">Exercise 3</a></li>
  <li><a href="/exercises/c/exercise_pointers/">Pointers</a></li>
  <li><a href="/exercises/c/exercise_files/">Files</a></li>
</ul>

<h2 id="exams">Prior Exams</h2>
<ul>
  <li><a href="tests/fsst2_midterm_f2021_a_de/">FSST 2 mid term f2021 (group A)</a></li>
  <li><a href="tests/fsst2_midterm_f2021_b_de/">FSST 2 mid term f2021 (group B)</a></li>
  <li><a href="tests/fsst2_final_f2021_a_de/">FSST 2 final f2021 (group A)</a></li>
  <li><a href="tests/fsst2_final_f2021_b_de/">FSST 2 final f2021 (group B)</a></li>
  <li><a href="tests/fsst2_final_f2021_c_de/">FSST 2 final f2021 (group C)</a></li>
  <li><a href="tests/fsst2_final_s2022_a_de/">FSST 2 final s2022 (group A)</a></li>
</ul>


<h2 id="links">Links</h2>
<ul>
  <li><a href="https://github.com/">GitHub</a></li>
  <li><a href="https://www.hackerrank.com/">HackerRank</a></li>
  <li><a href="https://replit.com/">Replit</a></li>
</ul>

<h3 id="tools">Tools</h3>
<ul>
  <li><a href="https://vscodium.com/">VSCodium</a> (text editor)</li>
  <li><a href="https://filezilla-project.org/download.php?show_all=1">FileZilla</a> (SFTP client)</li>
  <li><a href="https://www.chiark.greenend.org.uk/~sgtatham/putty/latest.html">PuTTY</a> (SSH client)</li>
</ul>

<h3 id="fsst2_image_sources">Online Images with Permissive Copyright</h3>
<ul>
  <li>Free high quality raster images:
    <a href="https://unsplash.com/">Unsplash</a>,
    <a href="https://pixabay.com/">Pixabay</a>,
    <a href="https://www.pexels.com/">Pexels</a></li>
  <li><a href="https://openclipart.org/">Openclipart</a> (vector based images of ... improvable quality</li>
</ul>

<h2 id="curriculum">Content of the Curriculum (2nd Year)</h2>
<a href="https://www.ris.bka.gv.at/eli/bgbl/ii/2015/262/ANL1.5/NOR40234867?ResultFunctionToken=52824552-7fbf-4180-b06a-4d04c703dfab&Position=1&SkipToDocumentPage=True&Abfrage=Bundesnormen&Kundmachungsorgan=&Index=&Titel=&Gesetzesnummer=&VonArtikel=&BisArtikel=&VonParagraf=&BisParagraf=&VonAnlage=&BisAnlage=&Typ=&Kundmachungsnummer=&Unterzeichnungsdatum=&FassungVom=15.09.2021&VonInkrafttretedatum=&BisInkrafttretedatum=&VonAusserkrafttretedatum=&BisAusserkrafttretedatum=&NormabschnittnummerKombination=Und&ImRisSeitVonDatum=&ImRisSeitBisDatum=&ImRisSeit=Undefined&ResultPageSize=100&Suchworte=ELEKTRONIK+UND+TECHNISCHE+INFORMATIK">Curriculum in the Legal Information System</a> (see Attachment 1.5)

<h4>Kompetenzmodul 3</h4>
<div><strong>Bildungs- und Lehraufgabe</strong></div>

<ul>
  <li>Bereich Programmiersprachen
    <ul>
      <li>vorgegebene Funktionalitäten strukturieren bzw. anhand eines Quellcodes nachvollziehen und analysieren</li>
    </ul>
  </li>
  <li>Bereich Hardwarenahe Programmentwicklung
    <ul>
      <li>Basisfunktionen implementieren und testen</li>
      <li>Entwickler- und Benutzerdokumentation erstellen</li>
    </ul>
  </li>
</ul>

<div><strong>Lehrstoff</strong></div>

<ul>
  <li>Bereich Programmiersprachen
    <ul>
      <li>Programm- und Datenstrukturen</li>
    </ul>
  </li>
  <li>Bereich Hardwarenahe Programmentwicklung
    <ul>
      <li>Basisalgorithmen, Systemdokumentation</li>
    </ul>
  </li>
</ul>

<h4>Kompetenzmodul 4</h4>
<div><strong>Bildungs- und Lehraufgabe</strong></div>

<ul>
  <li>Bereich Betriebssysteme
    <ul>
      <li>Vorgegebene systemnahe Befehle verwenden</li>
    </ul>
  </li>
  <li>Bereich Programmiersprachen
    <ul>
      <li>Datenstrukturen definieren, anwenden und speichern</li>
    </ul>
  </li>
  <li>Bereich Hardwarenahe Programmentwicklung
    <ul>
      <li>strukturierte Mikrocontrollerprogramme erstellen</li>
    </ul>
  </li>
  <li>Bereich Web- und Netzwerkprogrammierung
    <ul>
      <li>Einfache Webseiten erstellen und benutzerfreundlich gestalten</li>
    </ul>
  </li>
</ul>

<div><strong>Lehrstoff</strong></div>

<ul>
  <li>Bereich Betriebssysteme
    <ul>
      <li>Anwendung von Systemsoftware</li>
    </ul>
  </li>
  <li>Bereich Programmiersprachen
    <ul>
      <li>Datenstrukturen, Dateiverwaltung</li>
    </ul>
  </li>
  <li>Bereich Hardwarenahe Programmentwicklung
    <ul>
      <li>Mikrocontroller Programmierung</li>
      <li>Wiederverwendbare Module</li>
    </ul>
  </li>
  <li>Bereich Web- und Netzwerkprogrammierung
    <ul>
      <li>Statische HTML-Seiten</li>
      <li>Grafikformate</li>
      <li>CSS</li>
    </ul>
  </li>
</ul>
